/*
    listPM list files under Presentation Manager. Uses Open Class Libarary.
    Copyright (C) 1996  Paul Elliott

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Paul Elliott
    3987 South Gessner #224
    Houston Tx 77063
    Paul.Elliott@Hrnowl.LoneStar.Org
*/
#ifndef EXWMBOX
#define EXWMBOX

#include <iwindow.hpp>                   // define window
#include <iexcbase.hpp>                  // exceptions
#include <ievent.hpp>                    // events
#include <imsgbox.hpp>                   // message boxes.


// ExceptionFn class that displays exceptions thrown...
// objects derived from IWindow::ExceptionFn can be set to b
// called when a window throw an exception.
class ExcWinMsgBox : public IWindow::ExceptionFn
{
     private:
     public:


        // display thrown exception on a message box.
        virtual Boolean handleException(IException& dispatch,IEvent& evt)
        {
             // message box.
             IMessageBox msg( evt.dispatchingWindow() );
             msg.show(dispatch);              // display exception
             return false;                    // hook not handle.
        };


};
#endif
